CREATE OR REPLACE TRIGGER STATUS_LOTECTB_BAIXAPAGA BEFORE DELETE ON BAIXAPAGA
FOR EACH ROW
DECLARE
  V_CDLOTE VARCHAR2(20);
  V_NRLANCLOTE VARCHAR2(06);
  V_DTINICCTBL DATE;
  V_DTFINACCTBL DATE;
  V_IDTPGERACAOCONT VARCHAR2(4);
BEGIN
   BEGIN
      SELECT IDTPGERACAOCONT
        INTO V_IDTPGERACAOCONT
        FROM PARAMCTBL;
   EXCEPTION
    WHEN NO_DATA_FOUND THEN
      V_IDTPGERACAOCONT := NULL;
   END;

   IF V_IDTPGERACAOCONT <> 'O' THEN

      BEGIN
         SELECT DTINICCTBL, DTFINACCTBL
           INTO V_DTINICCTBL, V_DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = :OLD.CDEMPRESA;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_DTINICCTBL := NULL;
         V_DTFINACCTBL := NULL;
      END;

      IF DELETING THEN
         IF :OLD.DTBAIXAPAG >= V_DTINICCTBL AND :OLD.DTBAIXAPAG <=  V_DTFINACCTBL THEN
            BEGIN
               SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                 INTO V_CDLOTE, V_NRLANCLOTE
                 FROM RELACBPAGLANLOT
                WHERE  CDFILIAL = :OLD.CDFILIAL
                  AND  NRBAIXAPAG = :OLD.NRBAIXAPAG;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_CDLOTE := NULL;
                 V_NRLANCLOTE := NULL;
            END;

            REVERTE_LOTE(:OLD.CDEMPRESA,V_CDLOTE);

            DELETE FROM RELACBPAGLANLOT
             WHERE CDEMPRESA = :OLD.CDEMPRESA
               AND NRLANCLOTE = V_NRLANCLOTE
               AND CDFILIAL = :OLD.CDFILIAL
               AND NRBAIXAPAG = :OLD.NRBAIXAPAG;

            DELETE FROM LANCLOTE
             WHERE CDEMPRESA = :OLD.CDEMPRESA
               AND CDLOTE = V_CDLOTE
               AND NRLANCLOTE = V_NRLANCLOTE;

         ELSE
            RAISE_APPLICATION_ERROR(-20501,'Excluso no permitida, data da baixa a pagar fora do perodo de integrao financeiro.',True);
         END IF;
      END IF;
   END IF;
END;
/

